using System;
using System.Collections.Generic;

/// @author  Vesa Lappalainen
/// @version 13.11.2012
/// <summary>
/// Listoista poistaminen
/// </summary>
public class Poistot
{
    /// <summary>
    /// Tutkitaan eri tapoja kutsua RemoveAll
    /// </summary>
    public static void Main()
    {
        List<string> sanat = new List<string>() { "kissa", "koira", "kana", "susi", "ankka" };

        Console.WriteLine(String.Join(" ", sanat));

        // sanat.RemoveAll(AlkaaKlla);
        string pois = "kissa";
        sanat.RemoveAll(OnkoSana);
        // sanat.RemoveAll(delegate(string sana) { return sana.CompareTo("kana") <= 0; });
        // sanat.RemoveAll( sana => sana.CompareTo("kana") <= 0);

        Console.WriteLine(String.Join(" ", sanat));

        Boolean OnkoSana(string sana) // sisäkkäinen aliohjelma
        {
            return sana == pois;
        }
    }


    public static Boolean AlkaaKlla(string sana)
    {
        if (sana.Length == 0) return false;
        return sana[0] == 'k';
    }

}
